
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Qa_inspectionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_inspections = await db.qa_inspections.create(
            {
                id: data.id || undefined,
        
        inspection_number: data.inspection_number
        ||
        null
            ,
            
        inspection_type: data.inspection_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        scheduled_at: data.scheduled_at
        ||
        null
            ,
            
        performed_at: data.performed_at
        ||
        null
            ,
            
        result: data.result
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await qa_inspections.setInspector( data.inspector || null, {
            transaction,
        });
        
        await qa_inspections.setMaterial( data.material || null, {
            transaction,
        });
        
        await qa_inspections.setInventory_lot( data.inventory_lot || null, {
            transaction,
        });
        
        await qa_inspections.setProduction_order( data.production_order || null, {
            transaction,
        });
        
        await qa_inspections.setProduction_lot( data.production_lot || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.qa_inspections.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: qa_inspections.id,
            },
            data.attachments,
            options,
        );
        

        return qa_inspections;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const qa_inspectionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                inspection_number: item.inspection_number
            ||
            null
            ,
            
                inspection_type: item.inspection_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                scheduled_at: item.scheduled_at
            ||
            null
            ,
            
                performed_at: item.performed_at
            ||
            null
            ,
            
                result: item.result
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const qa_inspections = await db.qa_inspections.bulkCreate(qa_inspectionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < qa_inspections.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.qa_inspections.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: qa_inspections[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return qa_inspections;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const qa_inspections = await db.qa_inspections.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.inspection_number !== undefined) updatePayload.inspection_number = data.inspection_number;
        
        
        if (data.inspection_type !== undefined) updatePayload.inspection_type = data.inspection_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.scheduled_at !== undefined) updatePayload.scheduled_at = data.scheduled_at;
        
        
        if (data.performed_at !== undefined) updatePayload.performed_at = data.performed_at;
        
        
        if (data.result !== undefined) updatePayload.result = data.result;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        updatePayload.updatedById = currentUser.id;

        await qa_inspections.update(updatePayload, {transaction});

        
        
        if (data.inspector !== undefined) {
            await qa_inspections.setInspector(
              
              data.inspector,
              
              { transaction }
            );
        }
        
        if (data.material !== undefined) {
            await qa_inspections.setMaterial(
              
              data.material,
              
              { transaction }
            );
        }
        
        if (data.inventory_lot !== undefined) {
            await qa_inspections.setInventory_lot(
              
              data.inventory_lot,
              
              { transaction }
            );
        }
        
        if (data.production_order !== undefined) {
            await qa_inspections.setProduction_order(
              
              data.production_order,
              
              { transaction }
            );
        }
        
        if (data.production_lot !== undefined) {
            await qa_inspections.setProduction_lot(
              
              data.production_lot,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.qa_inspections.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: qa_inspections.id,
            },
            data.attachments,
            options,
        );
        

        return qa_inspections;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_inspections = await db.qa_inspections.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of qa_inspections) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of qa_inspections) {
                await record.destroy({transaction});
            }
        });


        return qa_inspections;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const qa_inspections = await db.qa_inspections.findByPk(id, options);

        await qa_inspections.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await qa_inspections.destroy({
            transaction
        });

        return qa_inspections;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const qa_inspections = await db.qa_inspections.findOne(
            { where },
            { transaction },
        );

        if (!qa_inspections) {
            return qa_inspections;
        }

        const output = qa_inspections.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.qa_measurements_qa_inspection = await qa_inspections.getQa_measurements_qa_inspection({
            transaction
        });
        
        
        
        
        
        
        output.inspector = await qa_inspections.getInspector({
            transaction
        });
        
        
        output.material = await qa_inspections.getMaterial({
            transaction
        });
        
        
        output.inventory_lot = await qa_inspections.getInventory_lot({
            transaction
        });
        
        
        output.production_order = await qa_inspections.getProduction_order({
            transaction
        });
        
        
        output.production_lot = await qa_inspections.getProduction_lot({
            transaction
        });
        
        
        output.attachments = await qa_inspections.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'inspector',
        
        where: filter.inspector ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspector.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.inspector.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.materials,
        as: 'material',
        
        where: filter.material ? {
          [Op.or]: [
            { id: { [Op.in]: filter.material.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.material.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.inventory_lots,
        as: 'inventory_lot',
        
        where: filter.inventory_lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inventory_lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.inventory_lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_orders,
        as: 'production_order',
        
        where: filter.production_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.production_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_lots,
        as: 'production_lot',
        
        where: filter.production_lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.production_lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.inspection_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'qa_inspections',
                        'inspection_number',
                        filter.inspection_number,
                    ),
                };
            }
            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'qa_inspections',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            scheduled_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    performed_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.scheduled_atRange) {
                const [start, end] = filter.scheduled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    scheduled_at: {
                    ...where.scheduled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    scheduled_at: {
                    ...where.scheduled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.performed_atRange) {
                const [start, end] = filter.performed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    performed_at: {
                    ...where.performed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    performed_at: {
                    ...where.performed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.inspection_type) {
                where = {
                    ...where,
                inspection_type: filter.inspection_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.result) {
                where = {
                    ...where,
                result: filter.result,
            };
            }
            


      

      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.qa_inspections.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'qa_inspections',
                        'inspection_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.qa_inspections.findAll({
            attributes: [ 'id', 'inspection_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['inspection_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.inspection_number,
        }));
    }

    
};

